/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */


import { HTMLStencilElement, JSXBase } from '@stencil/core/internal';


export namespace Components {
  interface AuthProvider {
    'logout': () => Promise<void>;
    'setToken': (token: any) => Promise<void>;
  }
  interface MyComponent {
    /**
    * The first name
    */
    'first': string;
    /**
    * The last name
    */
    'last': string;
    /**
    * The middle name
    */
    'middle': string;
  }
  interface SigninForm {
    'apiUrl': string;
    'setToken': (token) => void;
  }
  interface SignupForm {
    'apiUrl': string;
  }
}

declare global {


  interface HTMLAuthProviderElement extends Components.AuthProvider, HTMLStencilElement {}
  var HTMLAuthProviderElement: {
    prototype: HTMLAuthProviderElement;
    new (): HTMLAuthProviderElement;
  };

  interface HTMLMyComponentElement extends Components.MyComponent, HTMLStencilElement {}
  var HTMLMyComponentElement: {
    prototype: HTMLMyComponentElement;
    new (): HTMLMyComponentElement;
  };

  interface HTMLSigninFormElement extends Components.SigninForm, HTMLStencilElement {}
  var HTMLSigninFormElement: {
    prototype: HTMLSigninFormElement;
    new (): HTMLSigninFormElement;
  };

  interface HTMLSignupFormElement extends Components.SignupForm, HTMLStencilElement {}
  var HTMLSignupFormElement: {
    prototype: HTMLSignupFormElement;
    new (): HTMLSignupFormElement;
  };
  interface HTMLElementTagNameMap {
    'auth-provider': HTMLAuthProviderElement;
    'my-component': HTMLMyComponentElement;
    'signin-form': HTMLSigninFormElement;
    'signup-form': HTMLSignupFormElement;
  }
}

declare namespace LocalJSX {
  interface AuthProvider extends JSXBase.HTMLAttributes<HTMLAuthProviderElement> {}
  interface MyComponent extends JSXBase.HTMLAttributes<HTMLMyComponentElement> {
    /**
    * The first name
    */
    'first'?: string;
    /**
    * The last name
    */
    'last'?: string;
    /**
    * The middle name
    */
    'middle'?: string;
  }
  interface SigninForm extends JSXBase.HTMLAttributes<HTMLSigninFormElement> {
    'apiUrl'?: string;
    'onSigninFail'?: (event: CustomEvent<any>) => void;
    'onSigninSuccess'?: (event: CustomEvent<any>) => void;
    'setToken'?: (token) => void;
  }
  interface SignupForm extends JSXBase.HTMLAttributes<HTMLSignupFormElement> {
    'apiUrl'?: string;
    'onSignupFail'?: (event: CustomEvent<any>) => void;
    'onSignupSuccess'?: (event: CustomEvent<any>) => void;
  }

  interface IntrinsicElements {
    'auth-provider': AuthProvider;
    'my-component': MyComponent;
    'signin-form': SigninForm;
    'signup-form': SignupForm;
  }
}

export { LocalJSX as JSX };


declare module "@stencil/core" {
  export namespace JSX {
    interface IntrinsicElements extends LocalJSX.IntrinsicElements {}
  }
}


